'''
Copyright (c) <2015> <Victor de Lorenzo's lab, http://www.cnb.csic.es/~meml/>
                     
Author: Angel Goni-Moreno, www.angelgm.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
'''

from packages import *
from report import *

def calculateOutline(cs, min_value, max_value,self):
    shapes = []
    for collection in cs.collections[min_value:max_value]:
        paths = collection.get_paths()
        for path in paths:
            try:
                shapes.append(Polygon(path.vertices))
            except:
                pass

    emptyShapes = []
    shapesSearch = shapes[:]
    n = 0
    beginBar(self)
    for shape in shapes:
        if len(shapes)<40:
            updateBar(self)
        else:
            if n%(len(shapes)/40)== 0: updateBar(self)
        n+=1
        include = True
        for shape2 in shapesSearch:
            if shape.contains(shape2) and (shape != shape2):
                shapesSearch.remove(shape)
                include = False
                break
        if include:
            emptyShapes.append(shape)
    endBar(self)
    return emptyShapes

def calculateOutlineWithLevels(cs, min_value, max_value,self):
    shapes = []
    for coll in range(len(cs.collections[min_value:max_value])):
        collection = cs.collections[coll+min_value]
        paths = collection.get_paths()
        for path in paths:
            shapes.append([Polygon(path.vertices),coll+min_value])

    emptyShapes = []
    shapesSearch = shapes[:]
    n = 0
    beginBar(self)
    for shape in shapes:
        if len(shapes)<40:
            updateBar(self)
        else:
            if n%(len(shapes)/40)== 0: updateBar(self)
        n+=1
        include = True
        for shape2 in shapesSearch:
            if shape[0].contains(shape2[0]) and (shape[0] != shape2[0]):
                shapesSearch.remove(shape)
                include = False
                break
        if include:
            emptyShapes.append(shape)
    endBar(self)
    return emptyShapes

def calculateCytometry(emptyShapesCell,fluoAnalysis,self):

    shapes_values = []
    for shape in emptyShapesCell:
        shapes_values.append([shape,0])
    n = 0
    beginBar(self)
    for shape in shapes_values:
        (xmin, ymin, xmax, ymax) = shape[0].bounds
        x_explore = int(xmin)
        value = 0
        if len(shapes_values)<40:
            updateBar(self)
        else:
            if n%(len(shapes_values)/40)== 0: updateBar(self)
        n+=1
        while x_explore <= xmax:
            y_explore = int(ymin)
            while y_explore <= ymax:
                point_coords = Point((x_explore,y_explore))
                if point_coords.within(shape[0]):
                    value += fluoAnalysis[2][y_explore][x_explore]
                y_explore+=1
            x_explore+=1
        shape[1] += value
    endBar(self)
    return shapes_values

